;
; NPM_DMA library ver 0.2
; for asm5900 assembler
;
; (c) Duke /Napalm 2001
;

; DMA registers
DEFINE		DMA02CH		00h
DEFINE		DMA02ADR	10h
DEFINE		DMA02SIZE	20h
DEFINE		DMA02TAG	30h

			
Dma02Wait	PROC	ALIGN 8
		
			lui	v0,1000h
			ori	v0,v0,A000h
waitloop:		lw	v1,DMA02CH(v0)
			andi	v1,v1,100h
			bne	v1,zero,@waitloop
			nop
			jr	ra
			nop

Dma02Wait	ENDP

			
SendPrim	PROC	ALIGN 8

			lui	v0,1000h
			ori	v0,v0,A000h
			sw	a0,DMA02TAG(v0)
			sw	zero,DMA02SIZE(v0)
			lwu	v1,DMA02CH(v0)
			ori	v1,v1,105h
			sw	v1,DMA02CH(v0)	
			jr	ra
			nop

SendPrim	ENDP
	

DmaReset	PROC	ALIGN 8

			lui	v0,1000h
			ori	v0,v0,A000h
			sw	zero,80h(v0)
			sw	zero,00h(v0)
			sw	zero,30h(v0)
			sw	zero,10h(v0)
			sw	zero,50h(v0)
			sw	zero,40h(v0)
			lui	v1,0
			ori	v1,v1,FF1Fh
			sw	v1,E010h-A000h(v0)
			lw	v1,E010h-A000h(v0)
			andi	v1,v1,FF1Fh
			sw	v1,E010h-A000h(v0)
			sw	zero,E000h-A000h(v0)
			sw	zero,E020h-A000h(v0)
			sw	zero,E030h-A000h(v0)
			sw	zero,E050h-A000h(v0)
			sw	zero,E040h-A000h(v0)
			lw	v1,E000h-A000h(v0)
			ori	v1,v1,1
			sw	v1,E000h-A000h(v0)
			jr	ra
			nop

DmaReset	ENDP