
			; a3 = ptr. text

printf		PROC
			sd	ra,0(sp)
new_char:		lbu	t0,0(a3)
			beq	t0,zero,code.printf.endprintf	; same as @endprintf
			addiu	a3,a3,1				; next char
			addiu	t0,t0,-32
			sll	t0,t0,3				; mul t0*8
			lui	t1,@font >> 16
			ori	t1,t1,@font&FFFFh
			addu	t0,t1,t0			; now points at char adr.
			lui	t2,0
			ori	t2,t2,8
			lui	t4,@translated_char >> 16
			ori	t4,t4,@translated_char&FFFFh

horz_loop:		lui	t3,0
			ori	t3,t3,8
			lbu	t5,0(t0)			; get first byte of src char = 8 pix
vert_loop:		andi	t1,t5,80h			; keep MSB
			srl	t1,t1,7
			lui	t9,@font_fcolor >> 16
			ori	t9,t9,@font_fcolor&FFFFh
			lw	t7,0(t9)
			bne	t1,zero,@not_bgcolor
			sll	t5,t5,1				; next pixel of src char
			lw	t7,4(t9)
not_bgcolor:
			sw	t7,0(t4)
			addi	t3,t3,-1	
			bne	t3,zero,@vert_loop
			addi	t4,t4,4				; next pixel of dest char
			addi	t2,t2,-1
			bne	t2,zero,@horz_loop
			addi	t0,t0,1; changed				; next char line in src
		
			lui	a0,0
			lui	v1,0
			ori	v1,v1,64h
			syscall
		
			; print char to vram
		
			lui	t0,@char2vram >> 16
			ori	t0,t0,@char2vram&FFFFh
			lui	t1,0
			ori	t1,t1,(8*8*4)/16
			lui	t2,@translated_char >> 16
			ori	t2,t2,@translated_char&FFFFh
			lui	at,1000h
			ori	at,at,A000h
			sw	t0,10h(at)
			lui	t0,0
			ori	t0,t0,6
			sw	t0,20h(at)
			lui	t0,0
			ori	t0,t0,101h
			sw	t0,0(at)
			jal	@Dma02Wait
			nop		
			sw	t1,20h(at)
			sw	t2,10h(at)
			sw	t0,0(at)
			jal	@Dma02Wait
			nop
		
			; next char
		
			lui	v0,@xy_pos>>16
			ori	v0,v0,@xy_pos&FFFFh
			lh	a1,0(v0)
			addiu	a1,a1,8
			sh	a1,0(v0)
			beq	zero,zero,@new_char
			nop
		
endprintf:		ld	ra,0(sp)
			jr	ra
			nop

printf		ENDP


			ALIGN	4
font:			INCLUDE BINARY "font.bin"

			ALIGN	16
char2vram:		DD		1000000000000004h
			DD		Eh
			DD		00A000000000000h,50h
			DW		0
xy_pos:			DH		100,100			; dest x,y
			DD		51h
			DW		8,8				; h,w
			DD		52h
			DD		0,53h
			DD		800000000000010h,0
	
			ALIGN	16
translated_char:
			DW		1,0,0,0,0,0,0,0
			DW		0,1,0,0,0,0,0,0
			DW		0,0,1,0,0,0,0,0
			DW		0,0,0,1,0,0,0,0
			DW		0,0,0,0,1,0,0,0
			DW		0,0,0,0,0,1,0,0
			DW		0,0,0,0,0,0,1,0
			DW		0,0,0,0,0,0,0,1

font_fcolor:		DW		FFFFFFh
font_bcolor:		DW		000000h


			ALIGN	16

setup_scr:		DD 		100000000000800Eh,Eh,A0000h,4Ch
			DD		8Ch
			DD		4Eh
			DW		27648,30976
			DD		18h
			DH		0,639,0,223
			DD		40h
			DD 		1,1Ah,1,46h,0,45h,70000h
			DD 		47h,30000h,47h,6,0,3F80000000000000h,1,79006C00h,5,87009400h,5,70000h,47h
